unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, Menus, ExtCtrls, ComCtrls, ToolWin, StdCtrls, Buttons,
  Spin, ImgList, Grids, Printers, Registry,
  StrUtils, Math, MPlayer, ShellAPI,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP;

const
  fileURLs            = 'urls.dat';
  fileAgents          = 'agents.dat';
  fileSearch          = 'search.dat';

  colLevel            = 3;

  strNoTitle          = '<no title>';
  boolTitlesExport    = False; { Enables you to hide/show Titles Export in the main menu... }

  urlSEPageRank       = 'http://www.google.com/ie?q=_KEYWORDS_&start=0&num=100';
  urlGoogleRank       = 'http://www.google.com/search?q=link:_BASEURL_';
  urlAlexaRank        = 'http://www.alexa.com/data/details/?url=_BASEURL_';
  urlTotalPages       = 'http://www.google.com/search?q=_BASEURL_+site:_BASEURL_';
  urlWHOIS            = 'http://www.whois.sc/domain-suggestions/?q=_BASEURL_&sub=Search';

  regFormPropsPath    = 'Xybercode\SEOSpider-1.1'; {Where in registry form props will be stored}

type
  TfrmMain = class(TForm)
    xpManifest: TXPManifest;
    barStatus: TStatusBar;
    pnlMain: TPanel;
    lstImages16: TImageList;
    pnlSettings: TPanel;
    lblURL: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    cobURL: TComboBox;
    rbtMaxLevel: TRadioButton;
    rbtCurrentDir: TRadioButton;
    rbtCurrentSite: TRadioButton;
    edtMaxLevel: TSpinEdit;
    cbxURLSleep: TCheckBox;
    edtURLTo: TSpinEdit;
    edtURLFrom: TSpinEdit;
    pnlSettingsTitle: TPanel;
    pnlResults: TPanel;
    imgURL: TImage;
    imgSleep: TImage;
    imgLinks: TImage;
    lbxLog: TListBox;
    Splitter1: TSplitter;
    Panel1: TPanel;
    imgUserAgent: TImage;
    lblUserAgent: TLabel;
    cobUserAgent: TComboBox;
    barProgress: TProgressBar;
    tmrURL: TTimer;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    dlgPrint: TPrintDialog;
    dlgCSV: TSaveDialog;
    mpComplete: TMediaPlayer;
    cbxAutoSizeColumns: TCheckBox;
    imgSearchFor: TImage;
    lblSearchFor: TLabel;
    cobSearchFor: TComboBox;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    ClearGrid1: TMenuItem;
    OpenResults1: TMenuItem;
    SaveResults1: TMenuItem;
    SaveSelectedResults1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    CSVExport1: TMenuItem;
    mnuTitlesExport: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    btnTitlesExport: TToolButton;
    btnStart: TSpeedButton;
    Shape1: TShape;
    ToolBar2: TToolBar;
    btnTools: TToolButton;
    pmnuTools: TPopupMenu;
    mnuCheckAll: TMenuItem;
    UncheckAll2: TMenuItem;
    InvertCheckedLinks2: TMenuItem;
    N5: TMenuItem;
    ViewLog1: TMenuItem;
    SaveLogtoFile1: TMenuItem;
    N6: TMenuItem;
    ClearLog1: TMenuItem;
    Panel2: TPanel;
    Label1: TLabel;
    lblTotalPages: TLabel;
    Label6: TLabel;
    lblCurrentLevel: TLabel;
    btnAbort: TToolButton;
    N7: TMenuItem;
    DeleteLinks1: TMenuItem;
    pmnuResults: TPopupMenu;
    mnuCheckAll2: TMenuItem;
    UncheckAll3: TMenuItem;
    InvertCheckedLinks3: TMenuItem;
    pmnuLog: TPopupMenu;
    ViewLog2: TMenuItem;
    SaveLogtoFile2: TMenuItem;
    N4: TMenuItem;
    ClearLog2: TMenuItem;
    Panel3: TPanel;
    Label4: TLabel;
    lblBaseURL: TLabel;
    Label10: TLabel;
    Panel4: TPanel;
    Bevel1: TBevel;
    lblHomeTitle: TLabel;
    lvResults: TListView;
    IdHTTP: TIdHTTP;
    procedure mnuExitClick(Sender: TObject);
    procedure edtMaxLevelChange(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edtURLFromChange(Sender: TObject);
    procedure cobURLKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tmrURLTimer(Sender: TObject);
    procedure btnAbortClick(Sender: TObject);
    procedure mnuClearClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuOpenClick(Sender: TObject);
    procedure mnuSaveSelectedClick(Sender: TObject);
    procedure mnuPrintClick(Sender: TObject);
    procedure mnuCSVExportClick(Sender: TObject);
    procedure mnuTitlesExportClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuCheckClick(Sender: TObject);
    procedure mnuDeleteClick(Sender: TObject);
    procedure btnClearLogClick(Sender: TObject);
    procedure btnSaveLogClick(Sender: TObject);
    procedure btnViewLogClick(Sender: TObject);
    procedure mnuInvertSelectionClick(Sender: TObject);
    procedure btnToolsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure IdHTTPRedirect(Sender: TObject; var dest: String;
      var NumRedirect: Integer; var Handled: Boolean;
      var VMethod: TIdHTTPMethod);
  private
    { Private declarations }
  public
    { Public declarations }
    Path              : String;           { Local application path }
    CurrentLevel      : Integer;          { Current search depth }
    AbortSearch,                          { Is 'Abort' button pressed? }
    GetSEPage,                            { Is it OK to get the next page from Search Engine? }
    GetURLPage        : Boolean;          { Is it OK to get the next page from URL? }
    Tags              : Array of String;  { List of tags to parse }
    extLinks,
    extLevels,
    Robots,                               { 'robots.txt' file... }
    LinksToIndex      : TStrings;         { List of file types to index }
    CurrentDirURL     : String;           { FIX for the current dir bug... }

    Function Log(Event: String): Integer;                         { Insert log events into a listbox }
    Function GetPage(URL, UserAgent: String): String;             { Retrieve a HTTP page }
    Function GetRobots(URL, UserAgent: String): TStrings;         { Retrieve the 'robots.txt' file }
    Function ExtractRootURL(URL: String;
      NoHTTP: Boolean = False): String;                           { Extracts root URL from the URL }
    Function ExtractURLPath(URL: String): String;                 { Extracts path from the URL }
    Function ExtractURLFile(URL: String): String;                 { Extracts file from the URL }
    Function ExtractURLParams(URL: String): String;               { Extracts params from the URL }
    Function ParsePage(BaseURL, Page: String; Robots: TStrings;
      ItemIndex: Integer = -1): TStrings;                         { Parses a page(string) for links/tags }
    Function AddLinkToGrid(Link: String): Integer;                { Inserts 1 link/row into results grid }
    Function AddLinksToList(List: TStrings): Integer;             { Inserts links/rows into link list }
    Function ProcessURL(URL, SearchFor, UserAgent: String; TryRobots: Boolean = False;
      ItemIndex: Integer = -1): Integer;                          { Processes the specified URL }
    Function URLAllowed(URL: String; Robots: TStrings): Boolean;  { Matches the URL against 'robots.txt' }
    Function NewTempFile: String;                                 { Generate a temporary filename }
    Function SetButtons(SearchStarted: Boolean): Integer;         { Enables/disables buttons/panels on search start/end }
    Function StartURLTimer: Integer;                              { Starts the URL timer }
    Function ContinueSearch(Level: Integer): Boolean;             { Search the level? }
    Function GetPageRank(Page: String; Link: String): String;     { Get SE page rank }
    Function GetPageTitle(URL, UserAgent: String): String;        { Get page title only... }
    Function GetDataFromURL(URL, UserAgent, StartString, EndString: String;
      DefaultValue: String = ''): String;                         { Gets data from URL between StartString and EndString }
    Function GetDataFromPage(Page, StartString,
      EndString: String): String;                                 { Gets data from page between StartString and EndString }
    Function FormatLink(Link, BaseURL: String): String;           { Formatrs a link with base URL... }
    Function LeftAdd(Nesto: String; Cega: String; Koliko: Integer): String;
    Function ASCIIDecode(Link: String): String;                   { Decode links from e.g &#65; to A }
    Function SearchPhraseExists(Page, SearchFor: String;
      AllWords: Boolean = True): Boolean;                         { Tries to locate the search phrase(s) in the page... }
  end;

var
  frmMain: TfrmMain;

implementation

uses About;

{$R *.dfm}

procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.edtMaxLevelChange(Sender: TObject);
begin
  rbtMaxLevel.Checked := True;
end;

Function TfrmMain.Log(Event: String): Integer;
begin
  If Event <> '' then begin
    lbxLog.Items.BeginUpdate;
    If lbxLog.Count > 1000 then
      lbxLog.Clear;

    lbxLog.Items.Add(DateTimeToStr(Now) + ': ' + Event);
    lbxLog.ItemIndex := lbxLog.Count - 1;
    lbxLog.Items.EndUpdate;
  end;
  Result := 0;
end;

Function TfrmMain.ContinueSearch(Level: Integer): Boolean;
begin
  Result := (Not AbortSearch);
  If Result then begin
    If rbtMaxlevel.Checked then
      Result := Level <= edtmaxLevel.Value
    else
      Result := True;
  end;
end;

procedure TfrmMain.btnStartClick(Sender: TObject);
var
  timeStart       : TDateTime;
  Cnt,
  oldLevel,
  Index           : Integer;
  tmpStr          : String;
  FoundItem,
  Proceed         : Boolean;

begin
  Proceed := True;
  If (lvResults.Items.Count > 0) then begin
    Case MessageDlg('Clear results grid?', mtConfirmation, [mbYes, mbNo, mbCancel], 0) of
      mrYes: begin
        lvResults.Clear();

        lblBaseURL.Caption := '-';
        lblHomeTitle.Caption := '-';

        lblTotalPages.Caption := '0';
        lblCurrentLevel.Caption := '0';
      end;
      mrNo: begin

      end;
      mrCancel: begin
        Proceed := False;
      end;
    end;
  end;

  If Proceed then begin
    extLinks.Clear; { FIX: List of links... }
    extLevels.Clear; { FIX: List of links... }
    SetButtons(True);
    Try
      { Take care of combo values... }
      If Trim(cobURL.Text) <> '' then begin
        tmpStr := cobURL.Text;
        Index := cobURL.Items.IndexOf(tmpStr);
        If Index > -1 then
          cobURL.Items.Delete(Index);
        cobURL.Items.Insert(0, tmpStr);
        cobURL.ItemIndex := 0;
      end;

      If Trim(cobUserAgent.Text) <> '' then begin
        tmpStr := cobUserAgent.Text;
        Index := cobUserAgent.Items.IndexOf(tmpStr);
        If Index > -1 then
          cobUserAgent.Items.Delete(Index);
        cobUserAgent.Items.Insert(0, tmpStr);
        cobUserAgent.ItemIndex := 0;
      end;

      If Trim(cobSearchFor.Text) <> '' then begin
        tmpStr := cobSearchFor.Text;
        Index := cobSearchFor.Items.IndexOf(tmpStr);
        If Index > -1 then
          cobSearchFor.Items.Delete(Index);
        cobSearchFor.Items.Insert(0, tmpStr);
        cobSearchFor.ItemIndex := 0;
      end;

      { Start the work... }
      Log('Start button pressed - URL: ' + cobURL.Text + ' - Phrase: ' + cobSearchFor.Text + ' - User-agent:' + cobUserAgent.Text);
      timeStart := Now;
      lblBaseURL.Caption := ExtractRootURL(cobURL.Text, True);

      lblTotalPages.Caption := '0';
      lblCurrentLevel.Caption := '0';

      CurrentLevel := 1;
      barProgress.Position := 0;
      CurrentDirURL := ExtractURLPath(cobURL.Text);
      ProcessURL(cobURL.Text, cobSearchFor.Text, cobUserAgent.Text, True);

      { Continue the search... }
      FoundItem := True;
      While FoundItem And ContinueSearch(CurrentLevel) do begin
        Cnt := 0;
        oldLevel := CurrentLevel;
        Inc(CurrentLevel);
        lblCurrentLevel.Caption := IntToStr(oldLevel);
        Application.ProcessMessages;
{        While (Not AbortSearch) And (Cnt < asgResults.RowCount) And (asgResults.Cells[1, Cnt] <> '') do begin }
        { FIX: Go through extLinks/extLevels instead... }
        While (Not AbortSearch) And (Cnt < extLinks.Count) And (extLinks.Strings[Cnt] <> '') do begin
          { Process current level only }
{          If (asgResults.Cells[1, Cnt] <> '') And (asgResults.Cells[2, Cnt] = '') And (asgResults.Cells[colLevel, Cnt] = IntToSTr(oldLevel)) then begin }
          { FIX: Go through extLinks/extLevels instead... }
          If (extLinks.Strings[Cnt] <> '') And (extLevels.Strings[Cnt] = IntToStr(oldLevel)) then begin
{            asgResults.Col := 2; }
            //TS asgResults.Row := asgResults.RowCount - 1;
            lvResults.ItemIndex := lvResults.Items.Count-1;
            lvResults.ItemFocused := lvResults.Items[lvResults.ItemIndex];
            { FIX: Go through extLinks/extLevels instead... }
            ProcessURL(extLinks.Strings[Cnt], cobSearchFor.Text, cobUserAgent.Text, False, Cnt);
            barProgress.StepIt;

            { FIX: Autosize URL & Page Title columns... }
            If cbxAutoSizeColumns.Checked then begin
              lvResults.Column[1].AutoSize := true;
              lvResults.Column[2].AutoSize := true;
              Application.ProcessMessages;
            end;
          end;
          Inc(Cnt);
        end;
        If extLevels.Count > 0 then
          FoundItem := extLevels.Strings[extLevels.Count - 1] = IntToStr(CurrentLevel)
        else
          FoundItem := False;
      end;

      { Get titles for last level pages... - TODO: Fix it... how? }
(*      Cnt := 1;
      barProgress.Max := extLinks.Count;
      While (Not AbortSearch) And (Cnt < asgResults.RowCount) do begin
        If (asgResults.Cells[1, Cnt] <> '' ) And (asgResults.Cells[colLevel, Cnt] = IntToStr(CurrentLevel))  And (asgResults.Cells[2, Cnt] = '') then begin
          asgResults.Col := 2;
          asgResults.Row := asgResults.RowCount - 1;
          asgResults.Cells[2, Cnt] := GetPageTitle(asgResults.Cells[1, Cnt], cobUserAgent.Text);
          barProgress.StepIt;

          { FIX: Autosize URL & Page Title columns... }
          If cbxAutoSizeColumns.Checked then begin
            asgResults.AutoSizeCol(2);
            Application.ProcessMessages;
          end;
        end;
        Inc(Cnt);
      end;
*)
      { Work done... }
      Log('Search completed in ' + FormatDateTime('hh:mm:ss.zzz', Now - timeStart));
      If FileExists(Path + 'complete.wav') then begin
        mpComplete.FileName := Path + 'complete.wav';
        mpComplete.Open;
        mpComplete.Play;
      end;

      { FIX: Autosize URL & Page Title columns... }
      If cbxAutoSizeColumns.Checked then begin
        lvResults.Column[1].AutoSize := true;
        lvResults.Column[2].AutoSize := true;
      end;

      barProgress.Position := 0;
      lvResults.SetFocus();
    Finally
      SetButtons(False);
    end;
  end;
  barProgress.Position := 0;
  AbortSearch := False;
end;

Function TfrmMain.GetPageTitle(URL, UserAgent: String): String;
var
  pageTitle,
  thePage           : String;
  idxStart,
  idxEnd            : Integer;

begin
  pageTitle := '';

  { Wait... }
  If Not(GetURLPage) then
    Log('Sleep interval delay...');
  While Not(GetURLPage) do begin
    Sleep(50);
    Application.ProcessMessages;
  end;

  If (Not AbortSearch) then begin
    Try
      thePage := GetPage(URL, UserAgent);

      { Activate sleep interval... }
      If cbxURLSleep.Checked then
        StartURLTimer;

      If (Not AbortSearch) then begin
        { Get links... }
        If thePage <> '' then begin
          { It's a page from the grid - get page title, too... }
          idxStart := Pos('<TITLE>', UpperCase(thePage));
          idxEnd := Pos('</TITLE>', UpperCase(thePage));

          If (idxStart > 0) And (idxEnd > idxStart) then
            pageTitle := Trim(Copy(thePage, idxStart + 7, idxEnd - idxStart - 7));

          If pageTitle = '' then
            pageTitle := strNoTitle;
        end
        else
          Log('Warning: Empty page returned - URL : ' + URL);
      end;
    Except
      on E: Exception do
        Log('Warning: ' + E.Message + ' - URL : ' + URL);
    end;
  end;

  Result := pageTitle;
end;

Function TfrmMain.SetButtons(SearchStarted: Boolean): Integer;
begin
  pnlSettings.Enabled := Not SearchStarted;

  btnAbort.Enabled := SearchStarted;
  AbortSearch := Not SearchStarted;

  Result := 0;
end;

Function TfrmMain.SearchPhraseExists(Page, SearchFor: String; AllWords: Boolean = True): Boolean;
var
  tmpPage,
  tmpSearch     : String;
  Cnt           : Integer;
  List          : TStrings;
  Found         : Boolean;

begin
  If AllWords then
    Result := True
  else
    Result := False;
  List := TStringList.Create;

  tmpPage := LowerCase(Page);
  tmpSearch := LowerCase(SearchFor);
  List.CommaText := tmpSearch; { FIX: DelimitedText replaced with CommaText... }

  Cnt := 0;
  While ((AllWords And Result) Or ((Not AllWords) And (Not Result))) And (Cnt < List.Count) do begin
    Found := Pos(Trim(List.Strings[Cnt]), tmpPage) > 0; { FIX: Trim added... }
    If AllWords then
      Result := Result And Found
    else
      Result := Result Or Found;

    Inc(Cnt);
  end;
end;

Function TfrmMain.ProcessURL(URL, SearchFor, UserAgent: String; TryRobots: Boolean = False; ItemIndex: Integer = -1): Integer;
var
  Links           : TStrings;
  theTitle,
  thePage         : String;
{  Cnt             : Integer; }

begin
  { Wait... }
  If Not(GetURLPage) then
    Log('Sleep interval delay...');
  While Not(GetURLPage) do begin
    Sleep(50);
    Application.ProcessMessages;
  end;

  If (Not AbortSearch) then begin
    If URL <> '' then begin
      { First, make the URL presentable... }
      If Copy(LowerCase(URL), 1, 4) <> 'http' then
        URL := 'http://' + URL;
      If Length(ExtractURLPath(URL)) > Length(URL) then
        URL := URL + '/';

      If (Not AbortSearch) then begin
        { Then get the 'robots.txt' file... }
        If TryRobots then
          Robots := GetRobots(URL, UserAgent);

        If (Not AbortSearch) then begin
          { Proceed to parsing... }
          If URLAllowed(URL, Robots) then begin
            Try
              thePage := GetPage(URL, UserAgent);

              { Activate sleep interval... }
              If cbxURLSleep.Checked then
                StartURLTimer;

              If (Not AbortSearch) then begin
                { Get links... }
                If thePage <> '' then begin
                  theTitle := GetDataFromPage(thePage, '<TITLE>', '</TITLE>');
                  If ItemIndex = -1 then begin
                    lblHomeTitle.Caption := theTitle;
                  end;

                  If SearchPhraseExists(thePage, SearchFor) then
                    AddLinkToGrid(URL + '|' + theTitle);

                  Links := ParsePage(URL, thePage, Robots, ItemIndex);
                  If ItemIndex = -1 then
                    Links.Insert(0, URL + '|' + lblHomeTitle.Caption);
                  If Links.Count > 0 then begin
                    { FIX: A bit modified... }
                    AddLinksToList(Links);
                  end;
                  FreeAndNil(Links);
                end
                else begin
                  { FIX: Empty pages should be shown if the search phrase is empty = all pages... }
                  If SearchPhraseExists(thePage, SearchFor) then
                    AddLinkToGrid(URL);
                  Log('Warning: Empty page returned - URL : ' + URL);
                end;
              end;
            Except
              on E: Exception do
                Log('Warning: ' + E.Message + ' - URL : ' + URL);
            end;
          end;
        end;
      end;
    end
    else
      Log('Warning: Empty URL');
  end;

  If AbortSearch then
    Log('Search aborted by user!');

  Result := 0;
end;

Function TfrmMain.URLAllowed(URL: String; Robots: TStrings): Boolean;
var
  Cnt,
  tmpLen                : Integer;
  Found                 : Boolean;

begin
  Result := True;
  If Assigned(Robots) then begin
    tmpLen := Length(ExtractRootURL(URL));
    Delete(URL, 1, tmpLen - 1);

    Cnt := 0;
    Found := False;
    While (Not Found) And (Cnt < Robots.Count) do begin
      Found := Pos(LowerCase(Robots.Strings[Cnt]), LowerCase(URL)) = 1;
      If Not Found then
        Inc(Cnt);
    end;
    Result := Not Found;
  end;
end;

Function TfrmMain.AddLinkToGrid(Link: String): Integer;

  // Search for specified URL in "URL" column
  Function FindURL(const AURL: String): Boolean;
  var i: Integer;
  begin
    Result := false;

    for i := 0 to lvResults.Items.Count-1 do
     if (lvResults.Items[i].SubItems[0] = AURL)
      then
       begin
         Result := true;
         break;
       end;
  end;

var
  tmpTitle,
  tmpLink       : String;
  li            : TListItem;

begin
  Result := 0;
  lvResults.Items.BeginUpdate;

  { Separate page title from the link - page_url[|page title] }
  tmpLink := Link;
  If Pos('|', tmpLink) > 0 then begin
    tmpTitle := Copy(tmpLink, Pos('|', tmpLink) + 1, Length(tmpLink) - Pos('|', tmpLink));
    tmpLink := Copy(tmpLink, 1, Pos('|', tmpLink) - 1);
  end
  else
    tmpTitle := '';

  If not FindURL(LowerCase(tmpLink)) {TS asgResults.Cols[1].IndexOf(LowerCase(tmpLink)) = -1} then begin
    { Does not exist in the grid - enter it... }
    li := lvResults.Items.Add();
    li.Checked := false;
    li.SubItems.Add(tmpLink);
    li.SubItems.Add(tmpTitle);
    li.SubItems.Add(IntToStr(Max(1, CurrentLevel - 1)));
    { Count and return added rows... }
    Inc(Result);
  end;

  { FIX: Autosize URL & Page Title columns... }
  If cbxAutoSizeColumns.Checked then begin
    lvResults.Column[1].AutoSize := true;
    lvResults.Column[2].AutoSize := true;
  end;

  lvResults.Items.EndUpdate();
  lblTotalPages.Caption := IntToStr(lvResults.Items.Count);
  lblCurrentLevel.Caption := IntToStr(CurrentLevel);
{  barProgress.Max := asgResults.RowCount - 1; }
  Application.ProcessMessages;
end;

Function TfrmMain.AddLinksToList(List: TStrings): Integer;
var
  tmpTitle,
  tmpLink       : String;
  Cnt           : Integer;

begin
  Result := 0;
  For Cnt := 0 to List.Count - 1 do begin
    { Separate page title from the link - page_url[|page title] }
    tmpLink := List.Strings[Cnt];
    If Pos('|', tmpLink) > 0 then begin
      tmpTitle := Copy(tmpLink, Pos('|', tmpLink) + 1, Length(tmpLink) - Pos('|', tmpLink));
      tmpLink := Copy(tmpLink, 1, Pos('|', tmpLink) - 1);
    end
    else
      tmpTitle := '';

    If extLinks.IndexOf(LowerCase(tmpLink)) = -1 then begin
      { Does not exist in the list - enter it... }
      extLinks.Add(tmpLink);
      extLevels.Add(IntToStr(CurrentLevel));
      { Count and return added rows... }
      Inc(Result);
    end;
  end;
  barProgress.Max := extLinks.Count;
  Application.ProcessMessages;
end;

Function TfrmMain.NewTempFile: String;
var
  TmpPath : String;
  TmpPathLen : Integer;

begin
  TmpPathLen := 512;
  SetLength(TmpPath, TmpPathLen + 1);
  TmpPathLen := GetTempPath(TmpPathLen, PChar(TmpPath));
  If TmpPathLen = 0 then
    TmpPath := 'c:\'
  else
    SetLength(TmpPath, TmpPathLen );
  If TmpPath[length(TmpPath)] <> '\' then
    TmpPath := TmpPath + '\';
  Result := Format('%s~WS-%d\', [TmpPath, GetTickCount]);
  If Not DirectoryExists(Result) then
    CreateDir(Result);

  Result := Result + 'get-file.tmp';
end;

Function TfrmMain.GetPage(URL, UserAgent: String): String;
var
  timeStart         : TDateTime;
  Rcvd              : TStrings;
  tmpFileName       : String;
{  NotFound          : Boolean; }

{  tmpPage           : TStrings; }

  RcvdStream        : TFileStream;
begin
  Result := '';
{  NotFound := False; }

  Log('Getting: ' + URL + '...');
  IdHTTP.Disconnect();
  IdHTTP.Request.UserAgent := UserAgent;
  tmpFileName := NewTempFile;
  RcvdStream := TFileStream.Create(tmpFileName, fmCreate);
  Try
    timeStart := Now;
    IdHTTP.Get(URL, RcvdStream);
    Log('Retrieved in ' + FormatDateTime('ss.zzz', Now - timeStart) + ' sec.');
  Except
{    If httpSpider.StatusCode = 404 then begin
      Log('Not Found: ' + URL);
      NotFound := True;
    end
    else }
      Log('Warning: GET Failed - StatusCode: ' + IntToStr(IdHTTP.ResponseCode) + ' - ReasonPhrase: ' + IdHTTP.ResponseText);
  end;

  {  If NotFound then begin
      Result := 'ERROR: 404 - Not Found';
    end
    else begin }
    If Assigned(RcvdStream) And (RcvdStream.Size > 0) then begin
      RcvdStream.Free();
      RcvdStream := nil;

      If FileExists(tmpFileName) then begin
        Rcvd := TStringList.Create;
        Rcvd.LoadFromFile(tmpFileName);
        Result := Rcvd.Text;
        FreeAndNil(Rcvd);
        DeleteFile(tmpFileName);
      end;
    end;
{  end; }

  Try
    RemoveDir(ExtractFilePath(tmpFileName));
  Except
  end;
end;

Function TfrmMain.GetRobots(URL, UserAgent: String): TStrings;
var
  tmpLine         : String;
  tmpList         : TStrings;
  Ph              : Integer;

begin
  Result := TStringList.Create;

  tmpList := TStringList.Create;
  tmpList.Text := GetPage(ExtractRootURL(URL) + 'robots.txt', UserAgent);

  Ph := 0;
  While tmpList.Count > 0 do begin
    tmpLine := Trim(tmpList.Strings[0]);
    tmpList.Delete(0);

    { Check for a \n first... }
    If (Ph = 1) And (tmpLine = '') then
      Ph := 0
    else begin
      { Remove comments... }
      If Pos('#', tmpLine) > 0 then
        Delete(tmpLine, Pos('#', tmpLine), Length(tmpLine) - Pos('#', tmpLine) + 1);
      tmpLine := Trim(tmpLine);

      { Examine the rest of the string... }
      If tmpLine <> '' then begin
        Case Ph of
          0: begin { Looking for User-agent... }
            If Pos('User-agent:', tmpLine) = 1 then begin
              If (Pos('*', tmpLine) > 0) Or (Pos(LowerCase(UserAgent), LowerCase(tmpLine)) > 0) then begin
                { Rule for all bots/this bot - start looking for Disallow... }
                Ph := 1;
              end;
            end;
          end;
          1: begin { User-agent found, adding Disallow }
            If Pos('Disallow:', tmpLine) = 1 then begin
              { Add URL to result list... }
              Delete(tmpLine, 1, 9);
{              If Copy(Trim(tmpLine), 1, 1) = '/' then
                Result.Add(ExtractRootURL(URL) + Copy(Trim(tmpLine), 2, Length(Trim(tmpLine)) - 1))
              else
                Result.Add(ExtractRootURL(URL) + Trim(tmpLine)); }
              Result.Add(Trim(tmpLine));
            end;
          end;
        end;
      end;
    end;
  end;

  { That's it... }
  FreeAndNil(tmpList);
end;

Function TfrmMain.ExtractRootURL(URL: String; NoHTTP: Boolean = False): String;
var
  Temp          : String;

begin
  Temp := Trim(LowerCase(URL));
  If Copy(Temp, 1, 4) = 'http' then begin
    Result := Copy(Temp, 1, Pos('//', Temp) + 1);
    Delete(Temp, 1, Pos('//', Temp) + 1);
  end
  else
    Result := 'http://';

  If Pos('/', Temp) > 0 then
    Temp := Copy(Temp, 1, Pos('/', Temp) - 1);

  If NoHTTP then
    Result := StringReplace(Temp, 'http://', '', [])
  else
    Result := Result + Temp + '/';
end;

Function TfrmMain.ExtractURLPath(URL: String): String;
var
  Temp          : String;

begin
  Temp := Trim(LowerCase(URL));
  If Copy(Temp, 1, 4) = 'http' then begin
    Result := Copy(Temp, 1, Pos('//', Temp) + 1);
    Delete(Temp, 1, Pos('//', Temp) + 1);
  end
  else
    Result := 'http://';

  If Pos('/', Temp) = 0 then begin
    Result := Result + Temp;
    Temp := '';
  end
  else begin
    While Pos('/', Temp) > 0 do begin
      Result := Result + Copy(Temp, 1, Pos('/', Temp));
      Delete(Temp, 1, Pos('/', Temp));
    end;
  end;

  If (Temp <> '') And (Pos('.', Temp) = 0) then
    Result := Result + Temp;

  If Copy(Result, Length(Result), 1) <> '/' then
    Result := Result + '/';
end;

Function TfrmMain.ExtractURLFile(URL: String): String;
var
  Temp          : String;

begin
  Temp := Trim(LowerCase(URL));
  If PosEx('/', Temp, 10) = 0 then
    Temp := ''
  else begin
    While Pos('/', Temp) > 0 do
      Delete(Temp, 1, Pos('/', Temp));

    If Pos('.', Temp) = 0 then
      Temp := '';

    If Pos('?', Temp) > 0 then
      Temp := Copy(Temp, 1, Pos('?', Temp) - 1)
    else If Pos('#', Temp) > 0 then
      Temp := Copy(Temp, 1, Pos('#', Temp) - 1)
    else If Pos('javascript', Temp) > 0 then
      Temp := Copy(Temp, 1, Pos('javascript', Temp) - 1)
    else If Pos('inktomisearch', Temp) > 0 then
      Temp := Copy(Temp, 1, Pos('inktomisearch', Temp) - 1);
  end;

  Result := Temp;
end;

Function TfrmMain.ExtractURLParams(URL: String): String;
var
  Temp          : String;

begin
  Temp := Trim(LowerCase(URL));
  If Pos('?', Temp) > 0 then
    Temp := Copy(Temp, Pos('?', Temp), Length(Temp) - Pos('?', Temp) + 1)
  else
    Temp := '';

  Result := Temp;
end;

Function TfrmMain.ParsePage(BaseURL, Page: String; Robots: TStrings; ItemIndex: Integer = -1): TStrings;
var
  tmpList         : TStrings;
{  pageTitle, }
  tmpExt,
  tmpStr          : String;
  idxStart,
  idxEnd,
  idxStart1,
  idxStart2,
  Offset,
  Index,
  Cnt             : Integer;
  OKToAdd         : Boolean;

begin
  Log('Parsing page : ' + Copy(Page, 1, 25) + '...');
  tmpList := TStringList.Create;
  BaseURL := ExtractURLPath(BaseURL);

  { Get page title }
(*  If ItemIndex > -1 then begin
    pageTitle := '';
    { It's a page from the grid - get page title, too... }
    idxStart := Pos('<TITLE>', UpperCase(Page));
    idxEnd := Pos('</TITLE>', UpperCase(Page));

    If (idxStart > 0) And (idxEnd > idxStart) then
      pageTitle := Trim(Copy(Page, idxStart + 7, idxEnd - idxStart - 7));

    If pageTitle <> '' then
      asgResults.Cells[2, ItemIndex] := pageTitle
    else
      asgResults.Cells[2, ItemIndex] := strNoTitle;
  end; *)

  { Parse page for all tags from tag list... }
  For Cnt := 0 to Length(Tags) - 1 do begin
    Offset := 1;
    Index := PosEx(Tags[Cnt], UpperCase(Page), Offset);
    While Index > 0 do begin
      idxStart1 := PosEx('"', Page, Index + Length(Tags[Cnt]));
      idxStart2 := PosEx('''', Page, Index + Length(Tags[Cnt]));
      If idxStart1 = 0 then
        idxStart := idxStart2
      else If idxStart2 = 0 then
        idxStart := idxStart1
      else
        idxStart := Min(idxStart1, idxStart2);
      If idxStart > Index then begin
        If idxStart1 = idxStart then
          idxEnd := PosEx('"', Page, idxStart + 1)
        else If idxStart2 = idxStart then
          idxEnd := PosEx('''', Page, idxStart + 1)
        else
          idxEnd := 0;

        If idxEnd > idxStart then begin
          tmpStr := FormatLink(Copy(Page, idxStart + 1, idxEnd - idxStart - 1), BaseURL);
          If Pos('#', tmpStr) > 0 then
            tmpStr := Copy(tmpStr, 1, Pos('#', tmpStr) - 1);
          If tmpStr <> '' then begin
            tmpExt := ExtractFileExt(ExtractURLFile(tmpStr));
            If (tmpExt = '') Or (LinksToIndex.IndexOf(tmpExt) > -1) then begin
              { Check to see if it's OK to follow it... }
              If Copy(LowerCase(tmpStr), 1, 4) <> 'http' then begin
                tmpStr := StringReplace(tmpStr, '//', '/', [rfReplaceAll]);
                If Copy(tmpStr, 1, 1) = '/' then
                  tmpStr := Copy(tmpStr, 2, Length(tmpStr) - 1);
                tmpStr := BaseURL + tmpStr;
              end;

              If rbtCurrentDir.Checked then begin
                OKToAdd := Pos(Copy(CurrentDirURL, 1, Length(CurrentDirURL) - 1), LowerCase(tmpStr)) = 1;
              end
              else If rbtCurrentSite.Checked then begin
                OKToAdd := Pos(ExtractRootURL(BaseURL), LowerCase(tmpStr)) = 1;
              end
              else begin
{                If Not cbxOutOfSite.Checked then }
                  OKToAdd := Pos(BaseURL, tmpStr) = 1
{                else
                  OKToAdd := True; }
{                OKToAdd := True; } { FIX: Restrict search to folder entered... }
              end;

              If OKToAdd And (URLAllowed(tmpStr, Robots)) then
                tmpList.Add(tmpStr);
            end;
          end;
        end;
      end;
      Offset := Index + 1;
      Index := PosEx(Tags[Cnt], UpperCase(Page), Offset);
    end;
  end;

  Result := TStringList.Create;
  Result.AddStrings(tmpList);
  FreeAndNil(tmpList);
end;

Function TfrmMain.ASCIIDecode(Link: String): String;
var
  Cnt         : Integer;
  
begin
  For Cnt := 32 to 125 do
    Link := StringReplace(Link, '&#' + IntToStr(Cnt) + ';', Chr(Cnt), [rfReplaceAll]);
  Result := Link;
end;

Function TfrmMain.FormatLink(Link, BaseURL: String): String;
var
  tmpBase,
  Temp            : String;
  idxDD           : Integer;

begin
  Link := ASCIIDecode(Link);
  If Pos('mailto:', LowerCase(Link)) > 0 then
    Temp := ''
  else If Pos('ftp:', LowerCase(Link)) > 0 then
    Temp := ''
  else If Pos('http', LowerCase(Link)) > 0 then begin
    If Pos('http', LowerCase(Link)) = 1 then
      Temp := Link
    else begin
      Temp := Link;
      While PosEx('http', LowerCase(Temp), 2) > 0 do
        Temp := Copy(Temp, PosEx('http', LowerCase(Temp), 2), Length(Temp) - PosEx('http', LowerCase(Temp), 2) + 1);
    end;
  end
  else If Pos('/', Link) = 1 then begin
    Temp := Link;
    Temp := StringReplace(Temp, '../', '', [rfReplaceAll]);
    Temp := StringReplace(Temp, './', '', [rfReplaceAll]);
    Temp := ExtractRootURL(BaseURL) + Copy(Temp, 2, Length(Temp) - 1);
  end
  else If Pos('..', Link) > 0 then begin
    Temp := Link;
    idxDD := Pos('../', Temp);
    While idxDD > 0 do begin
      If idxDD = 1 then begin
        { Truncate the last folder from base url..  }
        tmpBase := Copy(BaseURL, Length(ExtractRootURL(BaseURL)) + 1, Length(BaseURL) - Length(ExtractRootURL(BaseURL)));
        If tmpBase <> '' then begin
          While (Pos('/', tmpBase) > 0) And (Pos('/', tmpBase) < Length(tmpBase)) do
            Delete(tmpBase, 1, Pos('/', tmpBase));
          { It's the last one... trunate it from base url & temp/link }
          BaseURL := Copy(BaseURL, 1, Length(BaseURL) - Length(tmpBase));
          Delete(Temp, idxDD, 3);
        end
        else begin
          { No more folders to truncate - remove all '../' }
          Temp := StringReplace(Temp, '../', '', [rfReplaceAll]);
        end;
      end
      else begin
        { Truncate prior folder from link/temp..  }
        tmpBase := Copy(Temp, 1, idxDD - 1);
        While (Pos('/', tmpBase) > 0) And (Pos('/', tmpBase) < Length(tmpBase)) do
          Delete(tmpBase, 1, Pos('/', tmpBase));
        { It's the last one... trunate it from base url & temp/link }
        Delete(Temp, idxDD, 3);
        Delete(Temp, idxDD - Length(tmpBase), Length(tmpBase));
      end;

      idxDD := Pos('../', Temp);
    end;
    Temp := BaseURL + Temp;
  end
  else begin
    Temp := BaseURL + Link;
  end;

  Temp := StringReplace(Temp, '../', '', [rfReplaceAll]);
  Temp := StringReplace(Temp, './', '', [rfReplaceAll]);
  If Pos('#', Temp) > 0 then
    Temp := Copy(Temp, 1, Pos('#', Temp) - 1);
  If Pos('?', Temp) > 0 then
    Temp := Copy(Temp, 1, Pos('?', Temp) - 1);
  If Pos('javascript', LowerCase(Temp)) > 0 then
    Temp := Copy(Temp, 1, Pos('javascript', LowerCase(Temp)) - 1);
  If Pos('inktomisearch', LowerCase(Temp)) > 0 then
    Temp := Copy(Temp, 1, Pos('inktomisearch', LowerCase(Temp)) - 1);

  Result := Temp;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
var Reg: TRegistry;
begin
  { Hide/Show Titles Export in the main menu... }
  mnuTitlesExport.Enabled := boolTitlesExport;
  mnuTitlesExport.Visible := boolTitlesExport;
  btnTitlesExport.Enabled := boolTitlesExport;
  btnTitlesExport.Visible := boolTitlesExport;

  Log('Application started...');
  Path := ExtractFilePath(Application.ExeName);
  CurrentDirURL := '';
  extLinks := TStringList.Create;
  extLevels := TStringList.Create;

  { Set the default values... }
  CurrentLevel := 0;
  AbortSearch := False;
  GetSEPage := True;
  GetURLPage := True;

  { List of tags to parse... }
  SetLength(Tags, 2);
  Tags[0] := ' HREF=';
  Tags[1] := ' SRC=';

  { List of links to index... }
  LinksToIndex := TStringList.Create;
  LinksToIndex.Add('.htm');
  LinksToIndex.Add('.html');
  LinksToIndex.Add('.shtml');
  LinksToIndex.Add('.php');
  LinksToIndex.Add('.asp');

  If FileExists(Path + fileURLs) then
    cobURL.Items.LoadFromFile(Path + fileURLs);
  cobURL.ItemIndex := -1; {Min(0, cobURL.Items.Count - 1)} { FIX: Required to be empty on startup... }

  If FileExists(Path + fileAgents) then
    cobUserAgent.Items.LoadFromFile(Path + fileAgents);
  cobUserAgent.ItemIndex := Min(0, cobUserAgent.Items.Count - 1);

  If FileExists(Path + fileSearch) then
    cobSearchFor.Items.LoadFromFile(Path + fileSearch);
  cobSearchFor.ItemIndex := -1;

  // Restore form props
  try
    Reg := TRegistry.Create();
    try
      Reg.RootKey := HKEY_CURRENT_USER;
      if Reg.OpenKey('\Software\'+regFormPropsPath, True) then
      begin
        if Reg.ValueExists('MaxLevelValue')
         then edtMaxLevel.Value := Reg.ReadInteger('MaxLevelValue');
        if Reg.ValueExists('MaxLevelChecked')
         then rbtMaxLevel.Checked := Reg.ReadBool('MaxLevelChecked');
        if Reg.ValueExists('CurDirChecked')
         then rbtCurrentDir.Checked := Reg.ReadBool('CurDirChecked');
        if Reg.ValueExists('CurSiteChecked')
         then rbtCurrentSite.Checked := Reg.ReadBool('CurSiteChecked');
        if Reg.ValueExists('URLSleep')
         then cbxURLSleep.Checked := Reg.ReadBool('URLSleep');
        if Reg.ValueExists('URLFrom')
         then edtURLFrom.Value := Reg.ReadInteger('URLFrom');
        if Reg.ValueExists('URLTo')
         then edtURLTo.Value := Reg.ReadInteger('URLTo');
        if Reg.ValueExists('AutoSizeColumns')
         then cbxAutoSizeColumns.Checked := Reg.ReadBool('AutoSizeColumns');

        Reg.CloseKey;
      end;
    finally
      Reg.Free;
    end;
  except
  end;
end;

procedure TfrmMain.edtURLFromChange(Sender: TObject);
begin
  tmrURL.Interval := edtURLFrom.Value * 1000;
end;

procedure TfrmMain.cobURLKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If Key = 13 then
    btnStart.Click;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  If Assigned(Robots) then
    FreeAndNil(Robots);
  If Assigned(extLinks) then
    FreeAndNil(extLinks);
  If Assigned(extLevels) then
    FreeAndNil(extLevels);

  Try
    cobURL.Items.SaveToFile(Path + fileURLs);
  Except
  end;

  Try
    cobUserAgent.Items.SaveToFile(Path + fileAgents);
  Except
  end;

  Try
    cobSearchFor.Items.SaveToFile(Path + fileSearch);
  Except
  end;
end;

Function TfrmMain.StartURLTimer: Integer;
begin
  If Not tmrURL.Enabled then begin
    GetURLPage := False;
    tmrURL.Enabled := True;
  end;
  Result := 0;
end;

procedure TfrmMain.tmrURLTimer(Sender: TObject);
begin
  tmrURL.Enabled := False;
  GetURLPage := True;
end;

procedure TfrmMain.btnAbortClick(Sender: TObject);
begin
  AbortSearch := True;
end;

Function TfrmMain.GetPageRank(Page: String; Link: String): String;
const
  strStart      = '<NOBR>';
  strEnd        = '. <A ';

var
  tmpPage,
  tmpLink       : String;
  Index         : Integer;
  idxStart,
  idxEnd        : Integer;

begin
  Result := '';
  If Page <> '' then begin
    tmpLink := ExtractURLPath(Link);
    Index := Pos(tmpLink, LowerCase(Page));
    If Index > 0 then begin
      tmpPage := Copy(Page, 1, Index);

      idxStart := PosEx(strStart, tmpPage, 10);
      While idxStart > 0 do begin
        Delete(tmpPage, 1, idxStart - 1);
        idxStart := PosEx(strStart, tmpPage, 10);
      end;

      idxStart := Pos(strStart, tmpPage);
      idxEnd := Pos(strEnd, tmpPage);
      If (idxStart > 0) And (idxEnd > 0) then
        Result := Copy(tmpPage, idxStart + Length(strStart), idxEnd - idxStart - Length(strStart));
    end;
  end;
  If Result = '' then
    Result := 'Not Top 100';
end;

procedure TfrmMain.mnuClearClick(Sender: TObject);
begin
  If MessageDlg('Clear results grid?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    lvResults.Clear();

    lblBaseURL.Caption := '-';
    lblHomeTitle.Caption := '-';

    lblTotalPages.Caption := '0';
    lblCurrentLevel.Caption := '0';
  end;
end;

procedure TfrmMain.mnuSaveClick(Sender: TObject);
var
  i: Integer;
  li: TListItem;
  f: TextFile;
begin
  If dlgSave.Execute then begin
    AssignFile(f, dlgSave.FileName);
    Rewrite(f);
    try
      for i := 0 to lvResults.Items.Count-1 do
       begin
         li := lvResults.Items[i];
         WriteLn(f, li.SubItems[0]{URL} + ' , ' + li.SubItems[1]{Title} + ' , ' + li.SubItems[2]{Level});
       end;
    finally
      CloseFile(f);
    end;
  end;
end;

procedure TfrmMain.mnuOpenClick(Sender: TObject);
var
  k           : Integer;
  li          : TListItem;
  f           : TextFile;
  s,url,title,level : String;

begin
  If dlgOpen.Execute then begin
    lvResults.Items.BeginUpdate();
    lvResults.Clear();

    AssignFile(f, dlgOpen.FileName);
    Reset(f);
    try
      while not eof(f) do
       begin
         ReadLn(f, s);
         url := copy(s, 1, pos(' , ', s)-1);   // URL
         delete(s, 1, pos(' , ', s)+2);
         k := Pos(' , ', ReverseString(s));
         title := copy(s, 1, length(s)-k-1-1); // Title
         delete(s, 1, length(s)-k+1);
         level := trim(s);                     // Level

         li := lvResults.Items.Add();
         li.SubItems.Add(url);
         li.SubItems.Add(title);
         li.SubItems.Add(level);
       end;
    finally
      CloseFile(f);
    end;

    { FIX: Autosize URL & Page Title columns... }
    If cbxAutoSizeColumns.Checked then begin
      lvResults.Column[1].AutoSize := true;
      lvResults.Column[2].AutoSize := true;
    end;

    lvResults.Items.EndUpdate;

    lblTotalPages.Caption := IntToStr(lvResults.Items.Count);
    lblCurrentLevel.Caption := '0';
    barProgress.Position := 0;
    barProgress.Max := lvResults.Items.Count;
  end;
end;

procedure TfrmMain.mnuSaveSelectedClick(Sender: TObject);
var
  i               : Integer;
  li              : TListItem;
  f               : TextFile;

begin
  { FIX: Modified code for saving selected rows only... }
  If dlgSave.Execute then begin
    AssignFile(f, dlgSave.FileName);
    Rewrite(f);
    try
      for i := 0 to lvResults.Items.Count-1 do
       begin
         li := lvResults.Items[i];

         if (li.Checked)
          then WriteLn(f, li.SubItems[0]{URL} + ' , ' + li.SubItems[1]{Title} + ' , ' + li.SubItems[2]{Level});
       end;
    finally
      CloseFile(f);
    end;
  end;
end;

procedure TfrmMain.mnuPrintClick(Sender: TObject);
var
  f: TextFile;
  i: Integer;
  li: TListItem;
begin
  If dlgPrint.Execute then begin

    AssignPrn(f);
    Rewrite(f);

    for i := 0 to lvResults.Items.Count-1 do
     begin
       li := lvResults.Items[i];
       WriteLn(f, li.SubItems[0]{URL} + ' , ' + li.SubItems[1]{Title} + ' , ' + li.SubItems[2]{Level});
     end;

    CloseFile(f);
    //TS asgResults.Print;
  end;
end;

procedure TfrmMain.mnuCSVExportClick(Sender: TObject);
var
  f: TextFile;
  i: Integer;
  li: TListItem;
begin
  If dlgCSV.Execute then begin
    AssignFile(f, dlgCSV.FileName);
    Rewrite(f);

    WriteLn(f, 'URL;Page Title;Level');
    for i := 0 to lvResults.Items.Count-1 do
     begin
       li := lvResults.Items[i];
       WriteLn(f, li.SubItems[0]{URL} + ';' + li.SubItems[1]{Title} + ';' + li.SubItems[2]{Level});
     end;

    CloseFile(f);
    //TS asgResults.Delimiter := ';';
    //TS asgResults.SaveToCSV(dlgCSV.FileName);
  end;
end;

procedure TfrmMain.mnuTitlesExportClick(Sender: TObject);
var
  lstTitles       : TStrings;
  i               : Integer;
begin
  If dlgSave.Execute then begin
    Try
      lstTitles := TStringList.Create;

      //TS lstTitles.AddStrings(asgResults.Cols[2]);
      for i := 0 to lvResults.Items.Count-1 do
       lstTitles.Add(lvResults.Items[i].SubItems[1]);

      lstTitles.SaveToFile(dlgSave.FileName);
    Finally
      FreeAndNil(lstTitles);
    end;
  end;
end;

procedure TfrmMain.mnuAboutClick(Sender: TObject);
begin
  Try
    frmAbout := TfrmAbout.Create(Application);
    frmAbout.ShowModal;
  Finally
    FreeAndNil(frmAbout);
  end;
end;

procedure TfrmMain.mnuCheckClick(Sender: TObject);
var
  YesNo           : Boolean;
  Cnt             : Integer;

begin
  { FIX: Added code for Check/Uncheck All }
  YesNo := (Sender = mnuCheckAll) or (Sender = mnuCheckAll2);
  lvResults.Items.BeginUpdate;
  For Cnt := 0 to lvResults.Items.Count - 1 do begin
    lvResults.Items[Cnt].Checked := YesNo;
  end;
  lvResults.Items.EndUpdate;
end;

procedure TfrmMain.mnuDeleteClick(Sender: TObject);
var
  i         : Integer;
  li        : TListItem;
begin
  { FIX: Added code for row deletion }
  lvResults.Items.BeginUpdate;
  If (lvResults.Items.Count > 0) then begin
    If MessageDlg('Delete selected row(s)?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
      i := 0;
      while (i < lvResults.Items.Count) do begin
        li := lvResults.Items[i];

        If li.Checked then
          lvResults.Items.Delete(i)
        else
          inc(i);
      end;
    end;
  end;
  lvResults.Items.EndUpdate;
end;

Function TfrmMain.GetDataFromURL(URL, UserAgent, StartString, EndString: String; DefaultValue: String = ''): String;
var
  thePage           : String;

begin
  Result := '';

  If (Not AbortSearch) then begin
    Try
      thePage := GetPage(URL, UserAgent);
      If (Not AbortSearch) then begin
        If thePage <> '' then
          Result := GetDataFromPage(thePage, StartString, EndString)
        else
          Log('Warning: Empty page returned - URL : ' + URL);
      end;
    Except
      on E: Exception do
        Log('Warning: ' + E.Message + ' - URL : ' + URL);
    end;
  end;

  If Result = '' then
    Result := DefaultValue;
end;

Function TfrmMain.GetDataFromPage(Page, StartString, EndString: String): String;
var
  idxStart,
  idxEnd        : Integer;

begin
  Result := '';
  If Page <> '' then begin
    idxStart := Pos(UpperCase(StartString), UpperCase(Page));
    If idxStart > 0 then begin
      idxEnd := PosEx(Uppercase(EndString), UpperCase(Page), idxStart);
      If (idxStart > 0) And (idxEnd > 0) then
        Result := Trim(Copy(Page, idxStart + Length(StartString), idxEnd - idxStart - Length(StartString)));
    end;
  end;
end;

procedure TfrmMain.btnClearLogClick(Sender: TObject);
begin
  lbxLog.Clear;
end;

procedure TfrmMain.btnSaveLogClick(Sender: TObject);
begin
  dlgSave.FileName := 'sitesearcher-' + FormatDateTime('yyyy-mm-dd_hh-nn-ss', Now) + '.log';
  If dlgSave.Execute then
    lbxLog.Items.SaveToFile(dlgSave.FileName);
  dlgSave.FileName := '';
end;

procedure TfrmMain.btnViewLogClick(Sender: TObject);
var
  FileName            : String;
begin
  Try
    FileName := NewTempFile;
    lbxLog.Items.SaveToFile(FileName);
    ShellExecute(Handle, 'open', 'notepad.exe', PAnsiChar(FileName), '', SW_SHOW);
  Except
  end;
end;

Function TfrmMain.LeftAdd(Nesto: String; Cega: String; Koliko: Integer): String;
begin
  While Length(Nesto) < Koliko do
    Nesto := Cega + Nesto;
  Result := Nesto;
end;

procedure TfrmMain.mnuInvertSelectionClick(Sender: TObject);
var
  Cnt             : Integer;

begin
  lvResults.Items.BeginUpdate;
  For Cnt := 0 to lvResults.Items.Count - 1 do begin
    lvResults.Items[Cnt].Checked := not lvResults.Items[Cnt].Checked;
  end;
  lvResults.Items.EndUpdate;
end;

procedure TfrmMain.btnToolsMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var pt: TPoint;
begin
  pt := btnTools.ClientToScreen(Point(0,btnTools.Height));
  pmnuTools.Popup(pt.X, pt.Y);
  btnTools.Down := false;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var Reg: TRegistry;
begin
  // Save form values
  try
    Reg := TRegistry.Create();
    try
      Reg.RootKey := HKEY_CURRENT_USER;
      if Reg.OpenKey('\Software\'+regFormPropsPath, True) then
      begin
        Reg.WriteInteger('MaxLevelValue', edtMaxLevel.Value);
        Reg.WriteBool('MaxLevelChecked', rbtMaxLevel.Checked);
        Reg.WriteBool('CurDirChecked', rbtCurrentDir.Checked);
        Reg.WriteBool('CurSiteChecked', rbtCurrentSite.Checked);
        Reg.WriteBool('URLSleep', cbxURLSleep.Checked);
        Reg.WriteInteger('URLFrom', edtURLFrom.Value);
        Reg.WriteInteger('URLTo', edtURLTo.Value);
        Reg.WriteBool('AutoSizeColumns', cbxAutoSizeColumns.Checked);

        Reg.CloseKey;
      end;
    finally
      Reg.Free;
    end;
  except
  end;
end;

procedure TfrmMain.IdHTTPRedirect(Sender: TObject; var dest: String;
  var NumRedirect: Integer; var Handled: Boolean;
  var VMethod: TIdHTTPMethod);
begin
  Handled := true;
end;

end.
